#coding-Utf-9-*-
import numpy as np
import os
import subprocess
import pickle
import string
import time
import sys
#from MF_inverse import *
from Auto_geometry_parametric import *
import math as m
import vmf_test
import vmf_hollow_OD
import vmf_hollow_ID
import vmf_bisection
import pandas as pd

from scipy.spatial import distance
from scipy.optimize import minimize
from mpl_toolkits.mplot3d import Axes3D
from mpl_toolkits.mplot3d.art3d import Poly3DCollection, Line3DCollection
import matplotlib.pyplot as plt 

from Auto_geometry_parametric import *

#############Can be changed##########################
cellType = "3" # from "2", "3", "4", "5", "6", "7", "8", "9", "10", "91" (or "92" if typeRand ="b")
typeRand   = "a" # "a" for random volume fraction and "b" for random radius
nx =2 #number of cell along x
ny =2 #number of cell along y
nz =2 #number of cell along z

VmFrMin = 0.05  #lower bound of random volume fraction, for geometry 8: 0.15 is a maximum, for other geometry 1. is a maximum
VmFrMax = 0.25  #max bound of random volume fraction, for geometry 8: 0.15 is a maximum, for other geometry 1. is a maximum

sizemin=0.2 #minimum size of unit cell
sizemax=2.5 # maximum size of unit cell

radiusmin =0.01 #minimum ratio of radius with respect to cell length
radiusmax =0.1 #maximum ratio of radius with respect to cell length

bow_h_min =0.5 #minimum bow of cell 8 with respect to cell length
bow_h_max = 0.8 #maximum bow of cell 8 with respect to cell length
bow_angle_min=65 #minimum bow angle of cell 8, automatically corrected from bow_h if too low
bow_angle_max=85 #maximum bow angle of cell 8, should be lower than 90

#############Cannot be changed##############################
vf_tpye=["a", "b"]
GeoID = []
GeoID.append(["2", "3", "4", "5", "6", "7", "8", "9", "91", "10"])
GeoID.append(["2", "3", "4", "5", "6", "7", "8", "9", "91", "92", "10"])
cell_num = np.array([nx,ny,nz])

####################################################
index=[ind for (ind, ele) in enumerate(vf_tpye) if ele==typeRand]
if(len(index)<1):
    print("You need to choose among ",vf_tpye," for typeRans")
    exit()
i=index[0]
vfr= vf_tpye[i]
index=[ind for (ind, ele) in enumerate(GeoID[i]) if ele==cellType]
if(len(index)<1):
    print("You need to choose among", GeoID[i], " for cellType")
    exit()

j=index[0]
cell_name= GeoID[i][j]

rho=str(128)       # defaut
length = cell_num[0]
width = cell_num[1]
height = cell_num[2]


####################################################

if cell_name=="8":
  if(VmFrMax>0.15):
     VmFrMax=0.15

VmFr=np.random.uniform(VmFrMin,VmFrMax)
sb = np.random.uniform(sizemin, sizemax)  #Set size of unit cell
Radius = np.random.uniform(radiusmin,radiusmax)*sb

bow_h=np.random.uniform(bow_h_min,bow_h_max)*sb
bow_angle=np.random.uniform(min(bow_angle_min,1.1*math.atan(sb/bow_h)*180./math.pi),bow_angle_max)

Geo, Radi = Geo_generator(cell_name, rho, vfr, length, width, height, sb, Radius, VmFr,bow_h,bow_angle)
V_R_S = [VmFr, Radi, sb]

print("Create geo file ", Geo, " cell type ", cell_name, " of volume fraction type", vfr, "with as results: volume fraction ", VmFr," Radius ", Radi)  
#runInPath(folder, fname, Geo, V_R_S)

#os.system("rm E_* *.geo *.msh")
