#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import numpy as np
import scipy as spy
import scipy.stats as spystats
import sys
from sys import exit
import pdb
import pandas as pd
import glob
import scipy.linalg   # SciPy Linear Algebra Library
import pickle

from scipy.stats import norm
from scipy.stats import uniform

from mpl_toolkits import mplot3d
import matplotlib.pyplot as plt

from scipy.stats import qmc
import utilRF

listTest=['cellRF','rnnRF']
testNb=1
test= listTest[testNb]

Keys=[]
if test=='cellRF':
  mechDir='../cellRF' # mechanical folder and file
  Keys=['Porosity']
elif test=='rnnRF':
  mechDir='../rnnRF' # mechanical folder and file
  Keys=['Radius [mm]','Length [mm]']
  
rfDir=mechDir+'/randomFields'

# read parameters
with open(rfDir+'/input.dat','rb') as data:
    Nsim=pickle.load(data)
    nVar=pickle.load(data)
    nDim=pickle.load(data)
    gPTetNb=pickle.load(data)
    gPNb=pickle.load(data)
    x=pickle.load(data)

#Nsim=6
if len(Keys)!=nVar:
  Keys=[]
  for i in range(nVar):
    Keys.append('var_'+str(i))

output = [np.zeros((len(x),nVar)) for i in range(Nsim)]  # [Nsim](nCXYZ,nVar)
for i in range(Nsim):
  rffilename=rfDir+'/RandField_'+str(i)+'.csv'
  print("read RF file ",rffilename)  
  outname=rfDir+'/RandField_'+str(i)+'.msh'
  randf = utilRF.RFReadOneRandField(rffilename,nVar,len(x))
  output[i] = randf

# extract the random field at discrete coord. grid points
var = np.zeros((Nsim,len(x),nVar))    # for 3D
for i in range(len(output)):    # Nsim = Nreals
  for j in range(nVar):
    var[i,:,j] = output[i][:,j]     # (Nsim,nCoord,nVar)

mean, std = utilRF.RFStatParams(var,nVar,len(x))    # mean, std = (nVar,nCXYZ)

print("Mean values are: ", mean)
print("Standard deviation values are: ", std)

fig=1
for i in range(nVar):
    plt.figure(fig)
    # plot histogram of normal distribution
    count, bins, ignored = plt.hist(var[:,0:len(x),i], bins=20, density=True,facecolor='blue', alpha=1.,linestyle='solid',histtype='stepfilled')
    #plt.rcParams["figure.figsize"] = [8.0, 6.0]
    plt.xlabel(Keys[i], fontsize=20)
    plt.ylabel('$\pi$', fontsize=20)
    plt.xticks(fontsize=20)
    plt.yticks(fontsize=20)
    plt.show()
    fig=fig+1

